gpt4 book ai didi

linux - Hashbang for Gnome .desktop 文件

转载 作者:IT王子 更新时间:2023-10-29 00:24:14 26 4
gpt4 key购买 nike

我希望能够在我的 .desktop 文件顶部添加一个 #! 注释,这样如果它具有执行权限并被执行,它实际上会运行。但是,我不知道 .desktop 文件的解释器是什么,所以我不知道在 hashbang 中写入哪个 /usr/bin/ 文件。有什么想法吗?


编辑:

到目前为止,我已经制作了一个可以执行桌面文件的小 bash 脚本 execdesktop:

`sed -nr 's/Exec=(.*)$/\\1/p' $1`

如果我随后将以下内容添加到我的 .desktop 文件中:

#!/usr/bin/execdesktop

然后它运行正常。此方法有效,但我宁愿不必使用它,因为它需要安装 execdesktop。

最佳答案

明确地说,Ignacio 是正确的 here .desktop 文件不应直接执行。这是可能的(如您所见),但不明智。

另外请注意,不要使用 xdg-open。如果有正确关联的 MIME 类型,它可能恰好可以工作,但这是不可靠的。

您应该使用 gtk-launch。它的用法如下:

gtk-launch APPLICATION [URI...]
gtk-launch app-name.desktop
gtk-launch app-name

这是 man 条目:

NAME

   gtk-launch - Launch an application

SYNOPSIS

   gtk-launch [APPLICATION] [URI...]

DESCRIPTION

   gtk-launch launches an application using the given name. The
application is started with proper startup notification on a default
display, unless specified otherwise.

gtk-launch takes at least one argument, the name of the application to
launch. The name should match application desktop file name, as
residing in /usr/share/application, with or without the '.desktop'
suffix.

If called with more than one argument, the rest of them besides the
application name are considered URI locations and are passed as
arguments to the launched application.

请注意,gtk-launch 需要安装 .desktop 文件(即位于 /usr/share/applications 或 < em>$HOME/.local/share/applications).

因此,为了解决这个问题,我们可以使用一个 hackish 的小 bash 函数,在启动它之前临时安装所需的 .desktop 文件。安装 .desktop 文件的“正确”方法是通过 desktop-file-install 但我将忽略它。

launch(){
(
# where you want to install the launcher to
appdir=$HOME/.local/share/applications

# the template used to install the launcher
template=launcher-XXXXXX.desktop

# ensure $1 has a .desktop extension, exists, is a normal file, is readable, has nonzero size
# optionally use desktop-file-validate for stricter checking
# if ! desktop-file-validate "$1" 2>/dev/null; then
if [[ ! ( $1 = *.desktop && -f $1 && -r $1 && -s $1 ) ]]; then
echo "ERROR: you have not supplied valid .desktop file" >&2
exit 1
fi

# ensure the temporary launcher is deleted upon exit
trap 'rm "$launcherfile" 2>/dev/null' EXIT

launcherfile=$(mktemp -p "$appdir" "$template")
launchername=${launcherfile##*/}

if cp "$1" "$launcherfile" 2>/dev/null; then
gtk-launch "$launchername" "${@:2}"
else
echo "ERROR: failed to copy launcher to applications directory" >&2
exit 1
fi

exit 0
)
}

您可以像这样使用它(如果需要,还可以传递其他参数或 URI):

launch ./path/to/shortcut.desktop

或者,我写了一个答案 here概述了启动 .desktop 文件的所有方法。它提供了一些可能有用的 gtk-launch 替代方案。

关于linux - Hashbang for Gnome .desktop 文件,我们在Stack Overflow上找到一个类似的问题: https://stackoverflow.com/questions/6020106/

26 4 0
Copyright 2021 - 2024 cfsdn All Rights Reserved 蜀ICP备2022000587号
广告合作:1813099741@qq.com 6ren.com